<?php

declare(strict_types=1);

namespace Drupal\commerce_alma_test\Plugin\Commerce\PaymentGateway;

use Drupal\commerce_alma\Plugin\Commerce\PaymentGateway\OffsitePaymentGateway;
use Drupal\commerce_alma_test\Api\Client;
use Drupal\commerce_payment\PaymentMethodTypeManager;
use Drupal\commerce_payment\PaymentTypeManager;
use Drupal\commerce_price\MinorUnitsConverterInterface;
use Drupal\Component\Datetime\TimeInterface;
use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\Core\Logger\LoggerChannelFactoryInterface;
use Drupal\Core\Url;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;

/**
 * Provides the Alma offsite Checkout payment gateway.
 */
class OffsiteTestPaymentGateway extends OffsitePaymentGateway {

  /**
   * The Alma API client.
   *
   * @var Drupal\commerce_alma\Client
   */
  protected $api;

  /**
   * {@inheritDoc}
   */
  public function __construct(array $configuration, string $plugin_id, mixed $plugin_definition, EntityTypeManagerInterface $entity_type_manager, PaymentTypeManager $payment_type_manager, PaymentMethodTypeManager $payment_method_type_manager, TimeInterface $time, MinorUnitsConverterInterface $minor_units_converter = NULL, EventDispatcherInterface $event_dispatcher, LoggerChannelFactoryInterface $logger_channel_factory) {
    parent::__construct($configuration, $plugin_id, $plugin_definition, $entity_type_manager, $payment_type_manager, $payment_method_type_manager, $time, $minor_units_converter, $event_dispatcher, $logger_channel_factory);

    if (!empty($this->configuration['mode']) && !empty($this->configuration['api_key'])) {
      $this->api = new Client();
    }
  }

}
